HDOJ题目3861 The King’s Problem(强连通,最小点覆盖)

The King’s Problem

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 1830    Accepted Submission(s): 666

Problem Description

In the Kingdom of Silence, the king has a new problem. There are N cities in the kingdom and there are M directional roads between the cities. That means that if there is a road from u to v, you can only go from city u to city v, but can’t go from city v to
city u. In order to rule his kingdom more effectively, the king want to divide his kingdom into several states, and each city must belong to exactly one state. What’s more, for each pair of city (u, v), if there is one way to go from
u to v and go from v to u, (u, v) have to belong to a same state. And the king must insure that in each state we can ether go from u to v or go from v to u between every pair of cities (u, v) without passing any city which belongs to other state.

Now the king asks for your help, he wants to know the least number of states he have to divide the kingdom into.

Input

The first line contains a single integer T, the number of test cases. And then followed T cases.

The first line for each case contains two integers n, m(0 < n <= 5000,0 <= m <= 100000), the number of cities and roads in the kingdom. The next m lines each contains two integers u and v (1 <= u, v <= n), indicating that there is a road going from city u to
city v.

Output

The output should contain T lines. For each test case you should just output an integer which is the least number of states the king have to divide into.

Sample Input

1
3 2
1 2
1 3

Sample Output

2

Source

2011 Multi-University Training Contest 3 - Host
by BIT

Recommend

lcy   |   We have carefully selected several similar problems for you:  3859 3868 3865 3862 3866

ac代码

#include<stdio.h>
#include<string.h>
#include<vector>
#include<string>
#include<iostream>
#define max(a,b) (a>b?a:b)
#define min(a,b) (a>b?b:a)
using namespace std;
int dfn[5050],low[5050],ins[5050],head[5050],belong[5050],stack[5050],link[5050];
int cnt,top,taj,time,n,m;
vector<int>vt[5050];
struct s
{
	int u,v,next;
}edge[100010*2];
void init()
{
	cnt=top=taj=time=0;
	memset(belong,-1,sizeof(belong));
	memset(ins,0,sizeof(ins));
	memset(low,-1,sizeof(low));
	memset(dfn,-1,sizeof(dfn));
	memset(head,-1,sizeof(head));
	memset(stack,0,sizeof(stack));
}
void add(int u,int v)
{
	edge[cnt].u=u;
	edge[cnt].v=v;
	edge[cnt].next=head[u];
	head[u]=cnt++;
}
void tarjin(int u)
{
	dfn[u]=low[u]=time++;
	stack[top++]=u;
	ins[u]=1;
	for(int i=head[u];i!=-1;i=edge[i].next)
	{
		int v=edge[i].v;
		if(dfn[v]==-1)
		{
			tarjin(v);
			low[u]=min(low[u],low[v]);
		}
		else
			if(ins[v])
				low[u]=min(dfn[v],low[u]);
	}
	if(dfn[u]==low[u])
	{
		taj++;
		int now;
		do
		{
			now=stack[--top];
			belong[now]=taj;
			ins[now]=0;
		}while(u!=now);
	}
}
int dfs(int u)
{
	for(int i=0;i<vt[u].size();i++)
	{
		int v=vt[u][i];
		if(!ins[v])
		{
			ins[v]=1;
			if(link[v]==-1||dfs(link[v]))
			{
				link[v]=u;
				return 1;
			}
		}
	}
	return 0;
}
int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		int i;
		init();
		scanf("%d%d",&n,&m);
		for(i=1;i<=n;i++)
			vt[i].clear();
		while(m--)
		{
			int u,v;
			scanf("%d%d",&u,&v);
			add(u,v);
		}
		for(i=1;i<=n;i++)
		{
			if(dfn[i]==-1)
			{
				tarjin(i);
			}
		}
		for(i=0;i<cnt;i++)
		{
			int u=edge[i].u;
			int v=edge[i].v;
			if(belong[u]!=belong[v])
			{
				vt[belong[u]].push_back(belong[v]);
			//	printf("%d %d %d %d\n",u,v,belong[u],belong[v]);
			}
		}
		memset(link,-1,sizeof(link));
		int ans=0;
		for(i=1;i<=taj;i++)
		{
			memset(ins,0,sizeof(ins));
			if(dfs(i))
				ans++;
		}
		printf("%d\n",taj-ans);
	}
}
时间: 2024-08-13 14:13:05

HDOJ题目3861 The King’s Problem(强连通,最小点覆盖)的相关文章

HDU 3861 The King’s Problem (强连通+二分匹配)

题目地址:HDU 3861 这题虽然是两个算法结合起来的.但是感觉挺没意思的..结合的一点也不自然,,硬生生的揉在了一块...(出题者不要喷我QAQ.) 不过这题让我发现了我的二分匹配已经好长时间没用过了..都快忘了..正好在省赛之前又复习了一下. 代码如下: #include <iostream> #include <string.h> #include <math.h> #include <queue> #include <algorithm>

HDU - 3861 The King’s Problem(强连通分量+最小路径覆盖)

题目大意:给出一张有向图,要求你将这些点进行划分,划分依据如下 1.如果两个点互相可达,那么这两个点必须在一个集合中 2.同一个集合中任意两个点u,v要满足,要么u能到达v,要么v能到达u 3.一个点只能被划分到一个集合 问最少能划分成几个点集 解题思路:首先先求出所有的强连通分量,满足条件1 满足条件2,3的话,就要求出最小路径覆盖 所以可以将所有的强连通分量进行缩点,桥作为连接,然后匈牙利一下,求出最大匹配数,再用强连通分量的数量-最大匹配数,就是答案了 #include <cstdio>

HDOJ 题目1528 Card Game Cheater(二分图最小点覆盖)

Card Game Cheater Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1357    Accepted Submission(s): 722 Problem Description Adam and Eve play a card game using a regular deck of 52 cards. The rul

HDOJ 题目1498 50 years, 50 colors(最小点覆盖)

50 years, 50 colors Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1792    Accepted Submission(s): 981 Problem Description On Octorber 21st, HDU 50-year-celebration, 50-color balloons floating

HDU 3861 The King&#39;s Problem(强连通分量缩点+最小路径覆盖)

http://acm.hdu.edu.cn/showproblem.php?pid=3861 题意: 国王要对n个城市进行规划,将这些城市分成若干个城市,强连通的城市必须处于一个州,另外一个州内的任意两个城市u,v,有从u到v的路径或从v到u的路径.求最少可以分成几个州. 思路: 这道题目挺好. 首先,强连通分量进行缩点,重新建图. 新建的图就是一个DAG图,接下来就转换成了最小路径覆盖问题. 最小路径覆盖就是用尽量少的不相交的简单路径覆盖DAG的所有顶点.每个顶点只属于一条路径,单个顶点也可以

hdu 3861 The King’s Problem (强连通+最小路径覆盖)

The King's Problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1637    Accepted Submission(s): 600 Problem Description In the Kingdom of Silence, the king has a new problem. There are N cit

HDU 3861 The King’s Problem(强连通+二分图最小路径覆盖)

HDU 3861 The King's Problem 题目链接 题意:给定一个有向图,求最少划分成几个部分满足下面条件 互相可达的点必须分到一个集合 一个对点(u, v)必须至少有u可达v或者v可达u 一个点只能分到一个集合 思路:先强连通缩点,然后二分图匹配求最小路径覆盖 代码: #include <cstdio> #include <cstring> #include <vector> #include <algorithm> #include <

hdu3861The King’s Problem (强连通 缩点+最小路径覆盖)

The King's Problem Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 1606 Accepted Submission(s): 584 Problem Description In the Kingdom of Silence, the king has a new problem. There are N cities in

HDU 3861.The King’s Problem 强联通分量+最小路径覆盖

The King’s Problem Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 2947    Accepted Submission(s): 1049 Problem Description In the Kingdom of Silence, the king has a new problem. There are N cit